﻿using C1.WPF.Grid;
using System;
using System.Threading.Tasks;
using System.Windows;
using WPFFlexGridSparklines.ViewModel;

namespace WPFFlexGridSparklines
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private SampleViewModel _viewModel;

        public MainWindow()
        {
            InitializeComponent();
            _viewModel = new SampleViewModel();
            DataContext = _viewModel;
            Loaded += OnLoaded;
        }

        private async void OnLoaded(object sender, RoutedEventArgs e)
        {
            while (true)
            {
                await Application.Current.Dispatcher.BeginInvoke(new Action(() =>
                {
                    // stock price update simulation
                    _viewModel.UpdatePrices();
                    _stockDataGrid.Refresh(GridCellType.Cell,
                        new GridCellRange(_stockDataGrid.ViewRange.Row,
                        _stockDataGrid.Columns["PriceData"].Index,
                        _stockDataGrid.ViewRange.Row2,
                        _stockDataGrid.Columns["PriceData"].Index + 2));
                }));
                await Task.Delay(1000);
            }
        }
    }
}
