﻿using System;
using System.Collections.ObjectModel;
using WPFFlexGridSparklines.Model;

namespace WPFFlexGridSparklines.ViewModel
{
    public class SampleViewModel
    {
        private Random _rnd;
        public ObservableCollection<StockPriceData> StockData { get; }

        public SampleViewModel()
        {
            StockData = new ObservableCollection<StockPriceData>();
            CreateStockPortfolio();
        }

        private void CreateStockPortfolio()
        {
            _rnd = new Random();
            StockData.Add(new StockPriceData("Apple (AAPL)", 189.54, 10));
            StockData.Add(new StockPriceData("Amazon (AMZN)", 2107.07, 15));
            StockData.Add(new StockPriceData("Google (GOOGL)", 2809.19, 50));
            StockData.Add(new StockPriceData("Cisco (CSCO)", 48.04, 200));
            StockData.Add(new StockPriceData("Microsoft (MSFT)", 323.15, 50));
            StockData.Add(new StockPriceData("Moderna (MRNA)", 129.12, 10));
            StockData.Add(new StockPriceData("Netflix (NFLX)", 289.11, 15));
            StockData.Add(new StockPriceData("Nvidia (NVDA)", 190.45, 50));
            StockData.Add(new StockPriceData("Meta (FB)", 455.81, 200));
            StockData.Add(new StockPriceData("eBay (EBAY)", 46.18, 50));

            for (int i = 0; i < 10; i++)
                UpdatePrices();
        }

        public void UpdatePrices()
        {
            foreach (var stock in StockData)
            {
                var delta = (int)(stock.CurrentPrice / 1000);
                var price = _rnd.Next((int)stock.CurrentPrice - (int)delta, (int)stock.CurrentPrice + (int)delta) + _rnd.NextDouble();

                if (price < 0)
                    price = 0;

                stock.CurrentPrice = price;
            }
        }
    }
}
